package st.martin.esknot;

import javax.microedition.khronos.egl.EGL10;
import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.egl.EGLContext;
import javax.microedition.khronos.egl.EGLDisplay;

import android.opengl.GLSurfaceView;

public class GLES2EGLContextFactory implements GLSurfaceView.EGLContextFactory {

	public static final int EGL_CONTEXT_CLIENT_VERSION = 0x3098;
	public static final int EGL_OPENGL_ES2_BIT = 4;

	public EGLContext createContext(EGL10 egl, EGLDisplay display, EGLConfig eglConfig) {
		int[] attribs = new int[3];
		attribs[0] = EGL_CONTEXT_CLIENT_VERSION;
		attribs[1] = 2;
		attribs[2] = EGL10.EGL_NONE;
		try {
			EGLConfig es2Config = chooseConfig(egl, display);
			EGLContext context = egl.eglCreateContext(display, es2Config, EGL10.EGL_NO_CONTEXT, attribs);
			if (context != null) {
				int retvalues[] = new int[1];
				boolean ret = egl.eglQueryContext(display, context, EGL_CONTEXT_CLIENT_VERSION, retvalues);
				if (ret && retvalues[0] == 2) {
					KnotRenderer.setGlesVersion(2);
					return context;
				}
				egl.eglDestroyContext(display, context);
			}
		} catch (IllegalArgumentException iae) {
		}
		KnotRenderer.setGlesVersion(1);
		return egl.eglCreateContext(display, eglConfig, EGL10.EGL_NO_CONTEXT, null);
	}

	public void destroyContext(EGL10 egl, EGLDisplay display, EGLContext context) {
		egl.eglDestroyContext(display, context);
	}

	public EGLConfig chooseConfig(EGL10 egl, EGLDisplay display) {
		int[] numConfigs = new int[1];
		int[] attribs = new int[5];
		attribs[0] = EGL10.EGL_RENDERABLE_TYPE;
		attribs[1] = EGL_OPENGL_ES2_BIT;
		attribs[2] = EGL10.EGL_DEPTH_SIZE;
		attribs[3] = 16;
		attribs[4] = EGL10.EGL_NONE;
		egl.eglChooseConfig(display, attribs, null, 0, numConfigs);
		if (numConfigs[0] <= 0)
			throw new IllegalArgumentException("No configs match");
		EGLConfig[] configs = new EGLConfig[numConfigs[0]];
		egl.eglChooseConfig(display, attribs, configs, numConfigs[0], numConfigs);
		return configs[0];
	}

}
